/// Test class for every features capable to be generated by the library
/// This class is for demonstration purposes and does not actually make sense or compiles correctly
Class cls.Features Extends (%Persistent, %XML.Adaptor) [ Inheritance = left, Final, GeneratedBy = pyobjectscript_gen ]
{

/// Parameter with type and default value
Parameter PARAM1 As STRING [ Final ] = "value";

/// Parameter with expression
Parameter COMPILETIME = {$zdatetime($h)};

/// Required property
Property Id As %Integer [ Required, InitialExpression = 0 ];

/// Property name with spaces and underscores, with property parameters
Property "Test Property_Parameters" As %String(XMLNAME="test_property_parameters", MAXLEN=50);

/// List Property example
Property ListOfString As List of %String;

/// Array Property example
Property ArrayOfInteger As Array of %Integer;

/// Simple method without arguments
Method SimpleMethod() As %Status
{
    Quit $$$OK
}

/// Simple class method without arguments
ClassMethod SimpleClassMethod() As %Status
{
    Quit $$$OK
}

/// Multi line method with arguments
Method MethodWithArgs(pInput As Ens.StringRequest, Output pOutput As Ens.StringResponse = {##class(Ens.StringResponse).%New()}) As %Status
{
    $$$TRACE(pInput.StringValue)
    set pOutput.StringValue = "Hello World"
    Quit $$$OK
}

/// Example query
Query TestQuery(id As %Integer) As %SQLQuery [ SqlProc ]
{
    SELECT * FROM Ens.MessageHeader
    WHERE ID = :id
}

/// Example index
Index IDX On Id As EXACT [ Internal ];

/// Example foreign key
ForeignKey EmpKey(EmpId) References MyApp.Employee(EmpIDX) [ OnDelete = cascade ];

/// Example projection
Projection Proj As %Projection.Java(ROOTDIR="c:\java");

Trigger TestTrigger [ Event = INSERT, Time = AFTER ]
{
    NEW id
    SET id = {ID}
    &sql(INSERT INTO LogTable (TableName, IDValue) VALUES ('MyApp.Person', :id))
}

/// Empty storage
Storage Default
{

}

}
